#ifndef __QUEUE_H_
#define __QUEUE_H_

#include <string>
#include <iostream>

class Queue {
private:
  int* elements;
  int headIndex;
  int tailIndex;
  int capacity;
  int size;
  int inspect(int i) const;
public:
  Queue(int capacity);
  void enqueue(int item);
  int dequeue(void);
  int head(void) const;
  bool is_empty(void) const;
  std::string to_string(void) const;
  ~Queue(void);

  void operator+=(int item);
  int operator--(void);
  bool operator!(void) const;
  int operator()(void) const;
  int operator[](int i) const;
  friend std::ostream& operator<<(std::ostream& os, const Queue& q);
};

#endif
