// A Bison parser, made by GNU Bison 3.7.3.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2020 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.





#include "cobra-parser.hh"


// Unqualified %code blocks.
#line 31 "cobra-parser.yy"

#include "cobra-ast.hh"
#include <string>
#include <vector>
#include <unordered_map>
#include <memory>
#include <utility>
#include "cobra.hh"

#line 56 "cobra-parser.cc"


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YYUSE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

namespace yy {
#line 148 "cobra-parser.cc"

  /// Build a parser object.
  cobra_parser::cobra_parser (cobra& driver_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg)
  {}

  cobra_parser::~cobra_parser ()
  {}

  cobra_parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/



  // by_state.
  cobra_parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  cobra_parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  cobra_parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  cobra_parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  cobra_parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  cobra_parser::symbol_kind_type
  cobra_parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  cobra_parser::stack_symbol_type::stack_symbol_type ()
  {}

  cobra_parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_cndn: // cndn
        value.YY_MOVE_OR_COPY< Cndn_ptr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_defn: // defn
        value.YY_MOVE_OR_COPY< Defn_ptr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_defns: // defns
        value.YY_MOVE_OR_COPY< Defn_vec > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expn: // expn
        value.YY_MOVE_OR_COPY< Expn_ptr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expns: // expns
        value.YY_MOVE_OR_COPY< Expn_vec > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_names: // names
        value.YY_MOVE_OR_COPY< Name_vec > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prgm: // prgm
        value.YY_MOVE_OR_COPY< Prgm_ptr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_stmt: // stmt
        value.YY_MOVE_OR_COPY< Stmt_ptr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_stmts: // stmts
        value.YY_MOVE_OR_COPY< Stmt_vec > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_NMBR: // NMBR
        value.YY_MOVE_OR_COPY< int > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_STRG: // STRG
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  cobra_parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_cndn: // cndn
        value.move< Cndn_ptr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_defn: // defn
        value.move< Defn_ptr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_defns: // defns
        value.move< Defn_vec > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expn: // expn
        value.move< Expn_ptr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_expns: // expns
        value.move< Expn_vec > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_names: // names
        value.move< Name_vec > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_prgm: // prgm
        value.move< Prgm_ptr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_stmt: // stmt
        value.move< Stmt_ptr > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_stmts: // stmts
        value.move< Stmt_vec > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_NMBR: // NMBR
        value.move< int > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_STRG: // STRG
        value.move< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  cobra_parser::stack_symbol_type&
  cobra_parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_cndn: // cndn
        value.copy< Cndn_ptr > (that.value);
        break;

      case symbol_kind::S_defn: // defn
        value.copy< Defn_ptr > (that.value);
        break;

      case symbol_kind::S_defns: // defns
        value.copy< Defn_vec > (that.value);
        break;

      case symbol_kind::S_expn: // expn
        value.copy< Expn_ptr > (that.value);
        break;

      case symbol_kind::S_expns: // expns
        value.copy< Expn_vec > (that.value);
        break;

      case symbol_kind::S_names: // names
        value.copy< Name_vec > (that.value);
        break;

      case symbol_kind::S_prgm: // prgm
        value.copy< Prgm_ptr > (that.value);
        break;

      case symbol_kind::S_stmt: // stmt
        value.copy< Stmt_ptr > (that.value);
        break;

      case symbol_kind::S_stmts: // stmts
        value.copy< Stmt_vec > (that.value);
        break;

      case symbol_kind::S_NMBR: // NMBR
        value.copy< int > (that.value);
        break;

      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_STRG: // STRG
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  cobra_parser::stack_symbol_type&
  cobra_parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_cndn: // cndn
        value.move< Cndn_ptr > (that.value);
        break;

      case symbol_kind::S_defn: // defn
        value.move< Defn_ptr > (that.value);
        break;

      case symbol_kind::S_defns: // defns
        value.move< Defn_vec > (that.value);
        break;

      case symbol_kind::S_expn: // expn
        value.move< Expn_ptr > (that.value);
        break;

      case symbol_kind::S_expns: // expns
        value.move< Expn_vec > (that.value);
        break;

      case symbol_kind::S_names: // names
        value.move< Name_vec > (that.value);
        break;

      case symbol_kind::S_prgm: // prgm
        value.move< Prgm_ptr > (that.value);
        break;

      case symbol_kind::S_stmt: // stmt
        value.move< Stmt_ptr > (that.value);
        break;

      case symbol_kind::S_stmts: // stmts
        value.move< Stmt_vec > (that.value);
        break;

      case symbol_kind::S_NMBR: // NMBR
        value.move< int > (that.value);
        break;

      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_STRG: // STRG
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  cobra_parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  cobra_parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YYUSE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YYUSE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  cobra_parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  cobra_parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  cobra_parser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  cobra_parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  cobra_parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  cobra_parser::debug_level_type
  cobra_parser::debug_level () const
  {
    return yydebug_;
  }

  void
  cobra_parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  cobra_parser::state_type
  cobra_parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  cobra_parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  cobra_parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  cobra_parser::operator() ()
  {
    return parse ();
  }

  int
  cobra_parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    // User initialization code.
#line 24 "cobra-parser.yy"
{
  // Initialize the initial location.
  yyla.location.begin.filename = yyla.location.end.filename = &driver.file;
}

#line 594 "cobra-parser.cc"


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_cndn: // cndn
        yylhs.value.emplace< Cndn_ptr > ();
        break;

      case symbol_kind::S_defn: // defn
        yylhs.value.emplace< Defn_ptr > ();
        break;

      case symbol_kind::S_defns: // defns
        yylhs.value.emplace< Defn_vec > ();
        break;

      case symbol_kind::S_expn: // expn
        yylhs.value.emplace< Expn_ptr > ();
        break;

      case symbol_kind::S_expns: // expns
        yylhs.value.emplace< Expn_vec > ();
        break;

      case symbol_kind::S_names: // names
        yylhs.value.emplace< Name_vec > ();
        break;

      case symbol_kind::S_prgm: // prgm
        yylhs.value.emplace< Prgm_ptr > ();
        break;

      case symbol_kind::S_stmt: // stmt
        yylhs.value.emplace< Stmt_ptr > ();
        break;

      case symbol_kind::S_stmts: // stmts
        yylhs.value.emplace< Stmt_vec > ();
        break;

      case symbol_kind::S_NMBR: // NMBR
        yylhs.value.emplace< int > ();
        break;

      case symbol_kind::S_NAME: // NAME
      case symbol_kind::S_STRG: // STRG
        yylhs.value.emplace< std::string > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 2: // prgm: defns stmt
#line 101 "cobra-parser.yy"
                 {
  Prgm_ptr p = Prgm_ptr{new Prgm {yystack_[1].value.as < Defn_vec > (),yystack_[0].value.as < Stmt_ptr > ()}};
  driver.result = p;
  yylhs.value.as < Prgm_ptr > () = p;
 }
#line 781 "cobra-parser.cc"
    break;

  case 3: // defns: %empty
#line 109 "cobra-parser.yy"
         { }
#line 787 "cobra-parser.cc"
    break;

  case 4: // defns: defns defn
#line 110 "cobra-parser.yy"
             {
  Defn_vec ds = yystack_[1].value.as < Defn_vec > ();
  Defn_ptr d = yystack_[0].value.as < Defn_ptr > ();
  ds.push_back(d);
  yylhs.value.as < Defn_vec > () = ds;
 }
#line 798 "cobra-parser.cc"
    break;

  case 5: // defn: "def" NAME "(" names ")" ":" stmt
#line 120 "cobra-parser.yy"
                            { yylhs.value.as < Defn_ptr > () = Defn_ptr {new Defn {yystack_[5].value.as < std::string > (),yystack_[3].value.as < Name_vec > (),yystack_[0].value.as < Stmt_ptr > ()}}; }
#line 804 "cobra-parser.cc"
    break;

  case 6: // stmt: NAME "=" expn
#line 124 "cobra-parser.yy"
                            { yylhs.value.as < Stmt_ptr > () = Stmt_ptr {new Asgn {yystack_[2].value.as < std::string > (),yystack_[0].value.as < Expn_ptr > ()}}; }
#line 810 "cobra-parser.cc"
    break;

  case 7: // stmt: NAME "+=" expn
#line 125 "cobra-parser.yy"
                            { yylhs.value.as < Stmt_ptr > () = Stmt_ptr {new Updt {yystack_[2].value.as < std::string > (),yystack_[0].value.as < Expn_ptr > ()}}; }
#line 816 "cobra-parser.cc"
    break;

  case 8: // stmt: NAME "(" expns ")"
#line 126 "cobra-parser.yy"
                            { yylhs.value.as < Stmt_ptr > () = Stmt_ptr {new PCll {yystack_[3].value.as < std::string > (),yystack_[1].value.as < Expn_vec > ()}}; }
#line 822 "cobra-parser.cc"
    break;

  case 9: // stmt: "print" "(" STRG ")"
#line 127 "cobra-parser.yy"
                            { yylhs.value.as < Stmt_ptr > () = Stmt_ptr {new PrtS {yystack_[1].value.as < std::string > ()}}; }
#line 828 "cobra-parser.cc"
    break;

  case 10: // stmt: "print" "(" expn ")"
#line 128 "cobra-parser.yy"
                            { yylhs.value.as < Stmt_ptr > () = Stmt_ptr {new PrtI {yystack_[1].value.as < Expn_ptr > ()}}; }
#line 834 "cobra-parser.cc"
    break;

  case 11: // stmt: "for" NAME "=" expn "to" expn ":" stmt
#line 130 "cobra-parser.yy"
                            { yylhs.value.as < Stmt_ptr > () = Stmt_ptr {new ForL {yystack_[6].value.as < std::string > (),yystack_[4].value.as < Expn_ptr > (),yystack_[2].value.as < Expn_ptr > (),yystack_[0].value.as < Stmt_ptr > ()}};}
#line 840 "cobra-parser.cc"
    break;

  case 12: // stmt: "while" cndn ":" stmt
#line 131 "cobra-parser.yy"
                            { yylhs.value.as < Stmt_ptr > () = Stmt_ptr {new Whle {yystack_[2].value.as < Cndn_ptr > (),yystack_[0].value.as < Stmt_ptr > ()}}; }
#line 846 "cobra-parser.cc"
    break;

  case 13: // stmt: "if" cndn ":" stmt
#line 132 "cobra-parser.yy"
                            { yylhs.value.as < Stmt_ptr > () = Stmt_ptr {new IfTn {yystack_[2].value.as < Cndn_ptr > (),yystack_[0].value.as < Stmt_ptr > ()}}; /* to do */ }
#line 852 "cobra-parser.cc"
    break;

  case 14: // stmt: "if" cndn ":" stmt "else" ":" stmt
#line 134 "cobra-parser.yy"
                            { yylhs.value.as < Stmt_ptr > () = Stmt_ptr {new IfTE {yystack_[5].value.as < Cndn_ptr > (),yystack_[3].value.as < Stmt_ptr > (),yystack_[0].value.as < Stmt_ptr > ()}}; }
#line 858 "cobra-parser.cc"
    break;

  case 15: // stmt: "return" expn
#line 135 "cobra-parser.yy"
                            { yylhs.value.as < Stmt_ptr > () = Stmt_ptr {new Rtrn {yystack_[0].value.as < Expn_ptr > ()}}; }
#line 864 "cobra-parser.cc"
    break;

  case 16: // stmt: "pass"
#line 136 "cobra-parser.yy"
                            { yylhs.value.as < Stmt_ptr > () = Stmt_ptr {new Pass {}}; }
#line 870 "cobra-parser.cc"
    break;

  case 17: // stmt: "begin" stmts "end"
#line 137 "cobra-parser.yy"
                            { yylhs.value.as < Stmt_ptr > () = Stmt_ptr {new Blck {yystack_[1].value.as < Stmt_vec > ()}}; }
#line 876 "cobra-parser.cc"
    break;

  case 18: // cndn: expn "<" expn
#line 141 "cobra-parser.yy"
                            { yylhs.value.as < Cndn_ptr > () = Cndn_ptr {new Less {yystack_[2].value.as < Expn_ptr > (),yystack_[0].value.as < Expn_ptr > ()}}; }
#line 882 "cobra-parser.cc"
    break;

  case 19: // cndn: expn "==" expn
#line 142 "cobra-parser.yy"
                            { yylhs.value.as < Cndn_ptr > () = Cndn_ptr {new Eqls {yystack_[2].value.as < Expn_ptr > (),yystack_[0].value.as < Expn_ptr > ()}}; }
#line 888 "cobra-parser.cc"
    break;

  case 20: // cndn: expn "<=" expn
#line 143 "cobra-parser.yy"
                            { yylhs.value.as < Cndn_ptr > () = Cndn_ptr {new LEql {yystack_[2].value.as < Expn_ptr > (),yystack_[0].value.as < Expn_ptr > ()}}; /* to do */ }
#line 894 "cobra-parser.cc"
    break;

  case 21: // cndn: cndn "and" cndn
#line 144 "cobra-parser.yy"
                            { yylhs.value.as < Cndn_ptr > () = Cndn_ptr {new AndC {yystack_[2].value.as < Cndn_ptr > (),yystack_[0].value.as < Cndn_ptr > ()}}; /* to do */ }
#line 900 "cobra-parser.cc"
    break;

  case 22: // cndn: cndn "or" cndn
#line 145 "cobra-parser.yy"
                            { yylhs.value.as < Cndn_ptr > () = Cndn_ptr {new OrCn {yystack_[2].value.as < Cndn_ptr > (),yystack_[0].value.as < Cndn_ptr > ()}}; /* to do */ }
#line 906 "cobra-parser.cc"
    break;

  case 23: // cndn: "not" cndn
#line 146 "cobra-parser.yy"
                            { yylhs.value.as < Cndn_ptr > () = Cndn_ptr {new NotC {yystack_[0].value.as < Cndn_ptr > ()}};    /* to do */ }
#line 912 "cobra-parser.cc"
    break;

  case 24: // cndn: "(" cndn ")"
#line 147 "cobra-parser.yy"
                            { yylhs.value.as < Cndn_ptr > () = yystack_[1].value.as < Cndn_ptr > (); }
#line 918 "cobra-parser.cc"
    break;

  case 25: // expn: expn "+" expn
#line 151 "cobra-parser.yy"
                            { yylhs.value.as < Expn_ptr > () = Expn_ptr {new Plus {yystack_[2].value.as < Expn_ptr > (),yystack_[0].value.as < Expn_ptr > ()}}; }
#line 924 "cobra-parser.cc"
    break;

  case 26: // expn: expn "-" expn
#line 152 "cobra-parser.yy"
                            { yylhs.value.as < Expn_ptr > () = Expn_ptr {new Mnus {yystack_[2].value.as < Expn_ptr > (),yystack_[0].value.as < Expn_ptr > ()}}; /* to do */ }
#line 930 "cobra-parser.cc"
    break;

  case 27: // expn: expn "*" expn
#line 153 "cobra-parser.yy"
                            { yylhs.value.as < Expn_ptr > () = Expn_ptr {new Tmes {yystack_[2].value.as < Expn_ptr > (),yystack_[0].value.as < Expn_ptr > ()}}; }
#line 936 "cobra-parser.cc"
    break;

  case 28: // expn: "random" "(" expn ")"
#line 154 "cobra-parser.yy"
                            { yylhs.value.as < Expn_ptr > () = Expn_ptr {new Rndm {yystack_[1].value.as < Expn_ptr > ()}}; }
#line 942 "cobra-parser.cc"
    break;

  case 29: // expn: "input" "(" STRG ")"
#line 155 "cobra-parser.yy"
                            { yylhs.value.as < Expn_ptr > () = Expn_ptr {new Inpt {yystack_[1].value.as < std::string > ()}}; }
#line 948 "cobra-parser.cc"
    break;

  case 30: // expn: NAME "(" expns ")"
#line 156 "cobra-parser.yy"
                            { yylhs.value.as < Expn_ptr > () = Expn_ptr {new FCll {yystack_[3].value.as < std::string > (),yystack_[1].value.as < Expn_vec > ()}}; }
#line 954 "cobra-parser.cc"
    break;

  case 31: // expn: NMBR
#line 157 "cobra-parser.yy"
                            { yylhs.value.as < Expn_ptr > () = Expn_ptr {new Nmbr {yystack_[0].value.as < int > ()}}; }
#line 960 "cobra-parser.cc"
    break;

  case 32: // expn: NAME
#line 158 "cobra-parser.yy"
                            { yylhs.value.as < Expn_ptr > () = Expn_ptr {new Lkup {yystack_[0].value.as < std::string > ()}}; }
#line 966 "cobra-parser.cc"
    break;

  case 33: // expn: "(" expn ")"
#line 159 "cobra-parser.yy"
                            { yylhs.value.as < Expn_ptr > () = yystack_[1].value.as < Expn_ptr > (); }
#line 972 "cobra-parser.cc"
    break;

  case 34: // expns: expn
#line 163 "cobra-parser.yy"
                            { yylhs.value.as < Expn_vec > () = Expn_vec { yystack_[0].value.as < Expn_ptr > () }; }
#line 978 "cobra-parser.cc"
    break;

  case 35: // expns: expns "," expn
#line 164 "cobra-parser.yy"
                            { Expn_vec es = yystack_[2].value.as < Expn_vec > (); es.push_back(yystack_[0].value.as < Expn_ptr > ()); yylhs.value.as < Expn_vec > () = es; }
#line 984 "cobra-parser.cc"
    break;

  case 36: // stmts: stmt
#line 168 "cobra-parser.yy"
                            { yylhs.value.as < Stmt_vec > () = Stmt_vec { yystack_[0].value.as < Stmt_ptr > () }; }
#line 990 "cobra-parser.cc"
    break;

  case 37: // stmts: stmts stmt
#line 169 "cobra-parser.yy"
                            { Stmt_vec ss = yystack_[1].value.as < Stmt_vec > (); ss.push_back(yystack_[0].value.as < Stmt_ptr > ()); yylhs.value.as < Stmt_vec > () = ss; }
#line 996 "cobra-parser.cc"
    break;

  case 38: // names: NAME
#line 173 "cobra-parser.yy"
                            { yylhs.value.as < Name_vec > () = Name_vec { yystack_[0].value.as < std::string > () }; }
#line 1002 "cobra-parser.cc"
    break;

  case 39: // names: names "," NAME
#line 174 "cobra-parser.yy"
                            { Name_vec ps = yystack_[2].value.as < Name_vec > (); ps.push_back(yystack_[0].value.as < std::string > ()); yylhs.value.as < Name_vec > () = ps; }
#line 1008 "cobra-parser.cc"
    break;


#line 1012 "cobra-parser.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  cobra_parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  cobra_parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  cobra_parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // cobra_parser::context.
  cobra_parser::context::context (const cobra_parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  cobra_parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        int yychecklim = yylast_ - yyn + 1;
        int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }



  int
  cobra_parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  cobra_parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const signed char cobra_parser::yypact_ninf_ = -25;

  const signed char cobra_parser::yytable_ninf_ = -1;

  const signed char
  cobra_parser::yypact_[] =
  {
     -25,     1,    -1,   -25,   -24,    61,    70,    -8,    70,   -25,
      23,    72,    46,   -25,   -25,    27,   -25,    49,    43,    48,
      70,    70,    52,   -25,   -12,    98,    17,     8,    65,    72,
       0,    72,    72,    72,    51,   -25,   -25,    44,    72,   110,
      88,   -25,    72,    61,    70,    70,    72,    72,    72,    72,
      72,    72,    72,    61,    66,   102,   109,     0,     0,     0,
      10,   -25,    25,    81,   112,   -25,   -25,    35,   -25,   -25,
     107,    74,    74,   -25,     0,     0,     0,    91,   127,   -25,
     -25,    72,   -25,   113,   124,   -25,   -25,   -25,    72,   125,
       0,   -25,    61,   122,    61,   -25,    61,   -25,   -25
  };

  const signed char
  cobra_parser::yydefact_[] =
  {
       3,     0,     0,     1,     0,     0,     0,     0,     0,    16,
       0,     0,     0,     4,     2,     0,    36,     0,     0,     0,
       0,     0,    32,    31,     0,     0,     0,     0,     0,     0,
      15,     0,     0,     0,     0,    17,    37,     0,     0,     0,
       0,    23,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     6,     7,    34,
       0,    38,     0,     0,     0,    24,    33,     0,    12,    21,
      22,    25,    26,    27,    18,    19,    20,     0,    13,     9,
      10,     0,     8,     0,     0,    29,    28,    30,     0,     0,
      35,    39,     0,     0,     0,     5,     0,    14,    11
  };

  const signed char
  cobra_parser::yypgoto_[] =
  {
     -25,   -25,   -25,   -25,    -5,     7,    -7,    77,   -25,   -25
  };

  const signed char
  cobra_parser::yydefgoto_[] =
  {
      -1,     1,     2,    13,    14,    24,    25,    60,    17,    62
  };

  const signed char
  cobra_parser::yytable_[] =
  {
      16,     3,     4,     5,    30,     6,     7,    15,     8,    43,
       9,    10,    36,    40,    11,    27,    44,    45,    46,    47,
      48,    55,    56,    26,    57,    58,    59,    39,    41,    53,
      12,    64,    81,    52,    82,    59,    44,    45,    68,    71,
      72,    73,    74,    75,    76,    77,    28,    83,    78,    84,
      34,    69,    70,     5,    35,     6,     7,    81,     8,    87,
       9,    10,    31,    32,    11,     5,    37,     6,     7,    33,
       8,    38,     9,    10,    90,    42,    11,    63,    18,    19,
      12,    93,    61,    18,    19,    18,    19,    95,    29,    97,
      79,    98,    12,    20,    48,    29,    22,    23,    54,    88,
      21,    22,    23,    22,    23,    85,    46,    47,    48,    46,
      47,    48,    66,    49,    50,    51,    46,    47,    48,    67,
      46,    47,    48,    49,    50,    51,    80,    46,    47,    48,
      46,    47,    48,    66,    65,    44,    86,    89,    44,    45,
      46,    47,    48,    96,    91,    92,    94
  };

  const signed char
  cobra_parser::yycheck_[] =
  {
       5,     0,     3,     4,    11,     6,     7,    31,     9,    21,
      11,    12,    17,    20,    15,     8,    28,    29,    18,    19,
      20,    28,    29,    31,    31,    32,    33,    20,    21,    21,
      31,    38,    22,    16,    24,    42,    28,    29,    43,    46,
      47,    48,    49,    50,    51,    52,    23,    22,    53,    24,
      23,    44,    45,     4,     5,     6,     7,    22,     9,    24,
      11,    12,    16,    17,    15,     4,    23,     6,     7,    23,
       9,    23,    11,    12,    81,    23,    15,    33,    13,    14,
      31,    88,    31,    13,    14,    13,    14,    92,    23,    94,
      24,    96,    31,    23,    20,    23,    31,    32,    33,     8,
      30,    31,    32,    31,    32,    24,    18,    19,    20,    18,
      19,    20,    24,    25,    26,    27,    18,    19,    20,    42,
      18,    19,    20,    25,    26,    27,    24,    18,    19,    20,
      18,    19,    20,    24,    24,    28,    24,    10,    28,    29,
      18,    19,    20,    21,    31,    21,    21
  };

  const signed char
  cobra_parser::yystos_[] =
  {
       0,    35,    36,     0,     3,     4,     6,     7,     9,    11,
      12,    15,    31,    37,    38,    31,    38,    42,    13,    14,
      23,    30,    31,    32,    39,    40,    31,    39,    23,    23,
      40,    16,    17,    23,    23,     5,    38,    23,    23,    39,
      40,    39,    23,    21,    28,    29,    18,    19,    20,    25,
      26,    27,    16,    21,    33,    40,    40,    40,    40,    40,
      41,    31,    43,    33,    40,    24,    24,    41,    38,    39,
      39,    40,    40,    40,    40,    40,    40,    40,    38,    24,
      24,    22,    24,    22,    24,    24,    24,    24,     8,    10,
      40,    31,    21,    40,    21,    38,    21,    38,    38
  };

  const signed char
  cobra_parser::yyr1_[] =
  {
       0,    34,    35,    36,    36,    37,    38,    38,    38,    38,
      38,    38,    38,    38,    38,    38,    38,    38,    39,    39,
      39,    39,    39,    39,    39,    40,    40,    40,    40,    40,
      40,    40,    40,    40,    41,    41,    42,    42,    43,    43
  };

  const signed char
  cobra_parser::yyr2_[] =
  {
       0,     2,     2,     0,     2,     7,     3,     3,     4,     4,
       4,     8,     4,     4,     7,     2,     1,     3,     3,     3,
       3,     3,     3,     2,     3,     3,     3,     3,     4,     4,
       4,     1,     1,     3,     1,     3,     1,     2,     1,     3
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const cobra_parser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "\"def\"", "\"begin\"",
  "\"end\"", "\"while\"", "\"for\"", "\"to\"", "\"if\"", "\"else\"",
  "\"pass\"", "\"print\"", "\"input\"", "\"random\"", "\"return\"",
  "\"=\"", "\"+=\"", "\"+\"", "\"-\"", "\"*\"", "\":\"", "\",\"", "\"(\"",
  "\")\"", "\"<\"", "\"==\"", "\"<=\"", "\"and\"", "\"or\"", "\"not\"",
  "NAME", "NMBR", "STRG", "$accept", "prgm", "defns", "defn", "stmt",
  "cndn", "expn", "expns", "stmts", "names", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const unsigned char
  cobra_parser::yyrline_[] =
  {
       0,   101,   101,   109,   110,   119,   124,   125,   126,   127,
     128,   129,   131,   132,   133,   135,   136,   137,   141,   142,
     143,   144,   145,   146,   147,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   163,   164,   168,   169,   173,   174
  };

  void
  cobra_parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  cobra_parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


} // yy
#line 1537 "cobra-parser.cc"

#line 177 "cobra-parser.yy"

void yy::cobra_parser::error (const location_type& l,
			      const std::string& m) {
  driver.error (l, m);
}
