#ifndef _COBRA_HH
#define _COBRA_HH
#include <string>
#include <memory>
#include "cobra-ast.hh"
#include "cobra-parser.hh"

# define YY_DECL \
  yy::cobra_parser::symbol_type yylex (cobra& driver)

YY_DECL;

class cobra {
public:
  Prgm_ptr result;
  cobra(void);
  virtual ~cobra(void);
  void scan_begin();
  void scan_end();
  bool trace_scanning;
  int parse(const std::string& f);
  std::string file;
  bool trace_parsing;
  void error(const yy::location& l, const std::string& m);
  void error(const std::string& m);
};
#endif 
