#include <memory>
#include <iostream>

#include "Arithmetic.hh"

int main(void) {
  std::unordered_map<std::string,int> vars {{"x",2},{"y",3},{"z",4}};

  std::shared_ptr<Expression> e2  {std::shared_ptr<Expression> {new LookUp {"x"}}};
  std::shared_ptr<Expression> e3  {std::shared_ptr<Expression> {new LookUp {"y"}}};
  std::shared_ptr<Expression> e4  {std::shared_ptr<Expression> {new LookUp {"z"}}};
  std::shared_ptr<Expression> e_3 {std::shared_ptr<Expression> {new Negation {e3}}};
  std::shared_ptr<Expression> e8  {std::shared_ptr<Expression> {new Number {8}}};
  std::shared_ptr<Expression> e5  {std::shared_ptr<Expression> {new Plus {e8,e_3}}};
  std::shared_ptr<Expression> e6  {std::shared_ptr<Expression> {new Plus {e2,e4}}};
  std::shared_ptr<Expression> e   {std::shared_ptr<Expression> {new Times {e5,e6}}};

  std::cout << "With x set to " << e2->evaluate(vars) << ", "; 
  std::cout << "y set to " << e3->evaluate(vars) << ", ";
  std::cout << "and z set to " << e4->evaluate(vars) << "," << std::endl;
  std::cout << "the value of " << e->to_string();
  std::cout << " is " << e->evaluate(vars) << "." << std::endl;
}
  

  
  
